diff --git a/src/Fl_Clock.cxx b/src/Fl_Clock.cxx
index a9271452b..0f1abd507 100644
--- a/src/Fl_Clock.cxx
+++ b/src/Fl_Clock.cxx
@@ -213,7 +213,25 @@ static void tick(void *v) {
   int usec;
   Fl::system_driver()->gettime(&sec, &usec);
   ((Fl_Clock*)v)->value((ulong)sec);
+
+  double delta = (1025000 - usec)/1000000.;
+  fprintf(stderr, "Fl_Clock - tick(), gettime = (%lu, %6d)", sec, usec);
+  fprintf(stderr, ", value() = %10lu, delta = %6.4f\n", ((Fl_Clock*)v)->value(), delta);
+
+  if (delta < 0.02) {
+    delta = 0.02;
+    fprintf(stderr, "    *** Delta correction --> %6.4f\n", delta);
+  }
+
+  fflush(stderr);
+
+#if (1) // original code
   Fl::add_timeout((1000000 - usec)/1000000., tick, v); // time till next second
+#elif (0) // original code with delay
+  Fl::add_timeout((1025000 - usec)/1000000., tick, v); // time till next second
+#else // new code with calculated delta value
+  Fl::add_timeout(delta, tick, v); // time till next second
+#endif
 }
 
 int Fl_Clock::handle(int event) {
